*! version 1.0.1, Ben Jann, 29nov2006

program define esto
	version 8.2
	gettoken first: 0
	if `"`first'"'=="clear" {
		if `"`0'"'!="clear" {
			di as err "invalid syntax"
			exit 198
		}
		_esto_clear
	}
	else {
		_esto_cleanglobal
		if `"`first'"'=="drop" {
			_esto_`0'
		}
		else {
			_esto_store `0'
		}
	}
end

program define _esto_clear
	local names $esto
	foreach name of local names {
		capt estimates drop `name'
	}
	global esto
	global esto_counter
end

program define _esto_cleanglobal
	local enames $esto
	if `"`enames'"'!="" {
		tempname hcurrent
		_return hold `hcurrent'
		qui _estimates dir
		local snames `r(names)'
		_return restore `hcurrent'
	}
	local names: list enames & snames
	global esto `names'
	if "`names'"=="" global esto_counter
end

program define _esto_drop
	local droplist `0'
	if `"`droplist'"'=="" {
		di as error "someting required"
		exit 198
	}
	local names $esto
	foreach item of local droplist {
		capt confirm integer number `item'
		if _rc {
			capt confirm name `item'
			if _rc {
				di as error `"`item' not allowed"'
				exit 198
			}
			local dropname `item'
		}
		else {
			if `item'<1 {
				di as error "`item' not allowed"
				exit 198
			}
			local dropname est`item'
		}
		if `:list dropname in names' {
			estimates drop `dropname'
			local names: list names - dropname
			di as txt "(" as res "`dropname'" as txt " dropped)"
		}
		else di as txt "(" as res "`dropname'" as txt " not found)"
	}
	global esto `names'
end


program define _esto_store, eclass
	capt _on_colon_parse `0'
	if !_rc {
		local command `"`s(after)'"'
		local 0 `"`s(before)'"'
	}
	syntax [name] [, ///
	 Title(passthru) ///
	 Refresh Refresh2(numlist integer max=1 >0) ///
	 ADDscalars(string) ///
	 noEsample ///
	 noCopy ]

// get previous esto names and counter
	local names $esto
	local counter $esto_counter
	if `"`counter'"'=="" local counter 0

// if name provided; set refresh on if name already in list
	if "`namelist'"!="" {
		if "`refresh2'"!="" {
			di as error "refresh() not allowed"
			exit 198
		}
		local name `namelist'
		if `:list name in names' local refresh refresh
		else {
			if "`refresh'"!="" {
				di as txt "(" as res "`name'" as txt " not found)"
			}
			local refresh
		}
		if "`refresh'"=="" local ++counter
	}
// if no name provided
	else {
		if "`refresh2'"!="" local refresh refresh
		if "`refresh'"!="" {
// refresh2 not provided => refresh last (if available)
			if "`refresh2'"=="" {
				if "`names'"=="" {
					di as txt "(nothing to refresh)"
					local refresh
				}
				else local name: word `:list sizeof names' of `names'
			}
// refresh2 provided => check availability
			else {
				if `:list posof "est`refresh2'" in names' {
					local name est`refresh2'
				}
				else {
					di as txt "(" as res "est`refresh2'" as txt " not found)"
					local refresh
				}
			}
		}
		if "`refresh'"=="" local ++counter
// set default name
		if "`name'"=="" local name est`counter'
	}

// run estimation command if provided
	`command'

// add scalars to e()
	if `"`addscalars'"'!="" {
		capt ParseAddscalars `addscalars'
		if _rc {
			di as err `"addscalars() invalid"'
			exit 198
		}
		if "`replace'"=="" {
			local elist `: e(scalars)' `: e(macros)' `: e(matrices)' `: e(functions)'
		}
		local forbidden b V sample
		while (1) {
			gettoken lhs rest: rest
			if `:list lhs in forbidden' {
				di as err `"`lhs' not allowed in addscalars()"'
				exit 198
			}
			if "`replace'"=="" {
				if `:list lhs in elist' {
					di as err `"e(`lhs') already defined"'
					exit 110
				}
			}
			gettoken rhs rest: rest
			capt eret scalar `lhs' = `rhs'
			if _rc {
				di as err `"addscalars() invalid"'
				exit 198
			}
			capture local result = e(`lhs')
			di as txt "(e(" as res `"`lhs'"' as txt ") = " ///
			 as res `result' as txt " added)"
			if `"`rest'"'=="" continue, break
		}
	}

// store estimates with e(sample)
	estimates store `name' , `copy' `title'
// remove e(sample) if -noesample- specified
	if "`esample'"!="" {
		capt confirm new var _est_`name'
		if _rc {
			tempname hcurrent
			_est hold `hcurrent', restore estsystem nullok
			qui replace _est_`name' = . in 1
			_est unhold `name'
			capt confirm new var _est_`name'
			if _rc qui drop _est_`name'
			else {
				di as error "somethings wrong; please contact author of -esto- " ///
				 "(see e-mail in help {help esto})"
				exit 498
			}
			_est hold `name', estimates
		}
	}

// store estimates with e(sample)
	else {
		estimates store `name' , `copy' `title'
	}
	

// report
	if "`refresh'"=="" {
		global esto `names' `name'
		global esto_counter `counter'
		if `"`namelist'"'=="" {
			di as txt "(" as res "`name'" as txt " stored)"
		}
	}
	else {
		if `"`namelist'"'=="" {
			di as txt "(" as res "`name'" as txt " refreshed)"
		}
	}
end

program ParseAddscalars
	syntax anything [ , Replace ]
	c_local rest "`anything'"
	c_local replace `replace'
end
